import { Context, Instruction, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { AssetV1, CollectionV1, executeV1 } from '../generated';
export type ExecuteInput = TransactionBuilder | Instruction[];
export type ExecuteArgs = Omit<Parameters<typeof executeV1>[1], 'programId' | 'instructionData' | 'asset' | 'collection'> & {
    asset: Pick<AssetV1, 'publicKey'>;
    collection?: Pick<CollectionV1, 'publicKey'>;
    instructions: ExecuteInput;
    signers?: Signer[];
};
export declare const execute: (context: Pick<Context, 'payer' | 'programs' | 'eddsa' | 'identity'>, args: ExecuteArgs) => TransactionBuilder;
